VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsToolTipFactory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
'   tooltip tipo editazione visual basic
'   mette in bold i parametri delle funzioni o sub
'   il testo e in corsivo
'
Option Explicit
Private Declare Function CreateWindowEx Lib "user32" _
   Alias "CreateWindowExA" (ByVal dwExStyle As Long, _
   ByVal lpClassName As String, ByVal lpWindowName As _
   String, ByVal dwStyle As Long, ByVal X As Long, _
   ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight _
   As Long, ByVal hWndParent As Long, ByVal hMenu As _
   Long, ByVal hInstance As Long, lpParam As Any) As Long

Private Declare Function SetWindowPos Lib "user32" _
   (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, _
   ByVal X As Long, ByVal Y As Long, ByVal cx As Long, _
   ByVal cy As Long, ByVal wFlags As Long) As Long

Private Declare Function SendMessage Lib "user32" _
   Alias "SendMessageA" (ByVal hwnd As Long, ByVal _
   wMsg As Long, ByVal wParam As Long, lParam As _
   Any) As Long

Private Declare Function GetClientRect Lib "user32" _
   (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function DestroyWindow Lib "user32" _
   (ByVal hwnd As Long) As Long

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type TOOLINFO
   cbSize As Long
   uFlags As Long
   hwnd As Long
   uid As Long
   RECT As RECT
   hinst As Long
   lpszText As String
   lParam As Long
End Type

Private Const CW_USEDEFAULT = &H80000000
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_NOSIZE = &H1
Private Const HWND_TOPMOST = -1
Private Const WM_USER = &H400
Private Const TTF_CENTERTIP = &H2
Private Const TTF_SUBCLASS = &H10
Private Const TTM_ADDTOOLA = (WM_USER + 4)
Private Const TTM_GETTEXTA = (WM_USER + 11)
Private Const TTM_SETMAXTIPWIDTH = (WM_USER + 24)
Private Const TTM_SETTIPBKCOLOR = (WM_USER + 19)
Private Const TTM_SETTIPTEXTCOLOR = (WM_USER + 20)
Private Const TTM_UPDATETIPTEXTA = (WM_USER + 12)
Private Const TTS_ALWAYSTIP = &H1
Private Const TTS_BALLOON = &H40
Private Const TOOLTIPS_CLASSA = "tooltips_class32"
Public Sub AssignToolTip(ByRef hTarget As Object, ByRef sMessage As String)
    Dim TipWindow As Long
    Dim ti As TOOLINFO
    Dim uid As Long
    Dim ToolTipText As String * 50
    Dim RECT As RECT
    uid = 0
    
    TipWindow = CreateWindowEx(0&, TOOLTIPS_CLASSA, "", _
       TTS_ALWAYSTIP, 0, 0, _
        0, 0, hTarget.hwnd, 0&, App.hInstance, 0&)
'       TTS_ALWAYSTIP Or TTS_BALLOON, 0, 0, _

    SetWindowPos TipWindow, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE
    GetClientRect hTarget.hwnd, RECT

    'Fill the TOOLINFO structure with info about
    'the target tool
    With ti
        .cbSize = Len(ti)
'        .uFlags = TTF_CENTERTIP + TTF_SUBCLASS
        .uFlags = TTF_SUBCLASS
        .hwnd = hTarget.hwnd
        .hinst = App.hInstance
        .uid = uid
        .lpszText = sMessage
        .RECT = RECT
        .lpszText = sMessage
    End With

    SendMessage TipWindow, TTM_ADDTOOLA, 0, ti
    SendMessage TipWindow, TTM_SETMAXTIPWIDTH, 0, 80
End Sub
